(** File generated by coq-of-ocaml *)
Require Import CoqOfOCaml.CoqOfOCaml.
Require Import CoqOfOCaml.Settings.

Require Import TezosOfOCaml.Proto_alpha.Environment.
Require TezosOfOCaml.Proto_alpha.Raw_level_repr.
Require TezosOfOCaml.Proto_alpha.Tez_repr.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_commitment_repr.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_errors_repr.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_level_repr.

(** The state of a transaction rollup is composed of [burn_per_byte]
    and [inbox_ema] fields. [initial_state] introduces their initial
    values. Both values are updated by [update_burn_per_byte] as the
    rollup progresses.

    [burn_per_byte] state the cost of burn per byte to be paid for
    each byte submitted to a transaction rollup inbox. [inbox_ema]
    is a key factor to impact the update of [burn_per_byte].

    [inbox_ema] is the N-block EMA to react to recent N-inbox size
    changes. N-block EMA is an exponential moving average (EMA), that
    is a type of moving average that places a greater weight and
    significance on the most N data points. The purpose of [inbox_ema]
    is to get lessened volatility of burn, that is more resistant to
    spurious spikes of [burn_per_byte].

   The state of the transaction rollup also keeps track of four pointers
   to four different rollup levels.

    - The [commitment_tail_level] is the level of the oldest
      finalized commitment still stored in the layer-1 storage.

    - The [commitment_head_level] is the level of the most recent
      unfinalized commitment in the layer-1 storage.

    - The [oldest_inbox_level] is the level of the oldest inbox still stored
      in the layer-1 storage.

    - The [head_level] is the level of the most recent inbox in the
      layer-1 storage. *)
Module t.
  Record record : Set := Build {
    last_removed_commitment_hash :
      option Tx_rollup_commitment_repr.Commitment_hash.t;
    commitment_tail_level : option Tx_rollup_level_repr.t;
    oldest_inbox_level : option Tx_rollup_level_repr.t;
    commitment_head_level :
      option
        (Tx_rollup_level_repr.t * Tx_rollup_commitment_repr.Commitment_hash.t);
    head_level : option (Tx_rollup_level_repr.t * Raw_level_repr.t);
    burn_per_byte : Tez_repr.t;
    inbox_ema : int }.
  Definition with_last_removed_commitment_hash last_removed_commitment_hash
    (r : record) :=
    Build last_removed_commitment_hash r.(commitment_tail_level)
      r.(oldest_inbox_level) r.(commitment_head_level) r.(head_level)
      r.(burn_per_byte) r.(inbox_ema).
  Definition with_commitment_tail_level commitment_tail_level (r : record) :=
    Build r.(last_removed_commitment_hash) commitment_tail_level
      r.(oldest_inbox_level) r.(commitment_head_level) r.(head_level)
      r.(burn_per_byte) r.(inbox_ema).
  Definition with_oldest_inbox_level oldest_inbox_level (r : record) :=
    Build r.(last_removed_commitment_hash) r.(commitment_tail_level)
      oldest_inbox_level r.(commitment_head_level) r.(head_level)
      r.(burn_per_byte) r.(inbox_ema).
  Definition with_commitment_head_level commitment_head_level (r : record) :=
    Build r.(last_removed_commitment_hash) r.(commitment_tail_level)
      r.(oldest_inbox_level) commitment_head_level r.(head_level)
      r.(burn_per_byte) r.(inbox_ema).
  Definition with_head_level head_level (r : record) :=
    Build r.(last_removed_commitment_hash) r.(commitment_tail_level)
      r.(oldest_inbox_level) r.(commitment_head_level) head_level
      r.(burn_per_byte) r.(inbox_ema).
  Definition with_burn_per_byte burn_per_byte (r : record) :=
    Build r.(last_removed_commitment_hash) r.(commitment_tail_level)
      r.(oldest_inbox_level) r.(commitment_head_level) r.(head_level)
      burn_per_byte r.(inbox_ema).
  Definition with_inbox_ema inbox_ema (r : record) :=
    Build r.(last_removed_commitment_hash) r.(commitment_tail_level)
      r.(oldest_inbox_level) r.(commitment_head_level) r.(head_level)
      r.(burn_per_byte) inbox_ema.
End t.
Definition t := t.record.

Definition initial_state : t :=
  {| t.last_removed_commitment_hash := None; t.commitment_tail_level := None;
    t.oldest_inbox_level := None; t.commitment_head_level := None;
    t.head_level := None; t.burn_per_byte := Tez_repr.zero; t.inbox_ema := 0 |}.

Definition encoding : Data_encoding.t t :=
  Data_encoding.conv
    (fun (function_parameter : t) =>
      let '{|
        t.last_removed_commitment_hash := last_removed_commitment_hash;
          t.commitment_tail_level := commitment_tail_level;
          t.oldest_inbox_level := oldest_inbox_level;
          t.commitment_head_level := commitment_head_level;
          t.head_level := head_level;
          t.burn_per_byte := burn_per_byte;
          t.inbox_ema := inbox_ema
          |} := function_parameter in
      (last_removed_commitment_hash, commitment_tail_level, oldest_inbox_level,
        commitment_head_level, head_level, burn_per_byte, inbox_ema))
    (fun (function_parameter :
      option Tx_rollup_commitment_repr.Commitment_hash.t *
        option Tx_rollup_level_repr.t * option Tx_rollup_level_repr.t *
        option
          (Tx_rollup_level_repr.t * Tx_rollup_commitment_repr.Commitment_hash.t)
        * option (Tx_rollup_level_repr.t * Raw_level_repr.t) * Tez_repr.t * int)
      =>
      let
        '(last_removed_commitment_hash, commitment_tail_level,
          oldest_inbox_level, commitment_head_level, head_level, burn_per_byte,
          inbox_ema) := function_parameter in
      {| t.last_removed_commitment_hash := last_removed_commitment_hash;
        t.commitment_tail_level := commitment_tail_level;
        t.oldest_inbox_level := oldest_inbox_level;
        t.commitment_head_level := commitment_head_level;
        t.head_level := head_level; t.burn_per_byte := burn_per_byte;
        t.inbox_ema := inbox_ema |}) None
    (Data_encoding.obj7
      (Data_encoding.req None None "last_removed_commitment_hash"
        (Data_encoding.option_value
          Tx_rollup_commitment_repr.Commitment_hash.encoding))
      (Data_encoding.req None None "commitment_tail_level"
        (Data_encoding.option_value Tx_rollup_level_repr.encoding))
      (Data_encoding.req None None "oldest_inbox_level"
        (Data_encoding.option_value Tx_rollup_level_repr.encoding))
      (Data_encoding.req None None "commitment_head_level"
        (Data_encoding.option_value
          (Data_encoding.obj2
            (Data_encoding.req None None "level" Tx_rollup_level_repr.encoding)
            (Data_encoding.req None None "hash"
              Tx_rollup_commitment_repr.Commitment_hash.encoding))))
      (Data_encoding.req None None "head_level"
        (Data_encoding.option_value
          (Data_encoding.obj2
            (Data_encoding.req None None "level" Tx_rollup_level_repr.encoding)
            (Data_encoding.req None None "tezos_level" Raw_level_repr.encoding))))
      (Data_encoding.req None None "burn_per_byte" Tez_repr.encoding)
      (Data_encoding.req None None "inbox_ema" Data_encoding.int31)).

Definition pp (fmt : Format.formatter) (function_parameter : t) : unit :=
  let '{|
    t.last_removed_commitment_hash := last_removed_commitment_hash;
      t.commitment_tail_level := commitment_tail_level;
      t.oldest_inbox_level := oldest_inbox_level;
      t.commitment_head_level := commitment_head_level;
      t.head_level := head_level;
      t.burn_per_byte := burn_per_byte;
      t.inbox_ema := inbox_ema
      |} := function_parameter in
  Format.fprintf fmt
    (CamlinternalFormatBasics.Format
      (CamlinternalFormatBasics.String_literal "oldest_inbox_level: "
        (CamlinternalFormatBasics.Alpha
          (CamlinternalFormatBasics.String_literal " cost_per_byte: "
            (CamlinternalFormatBasics.Alpha
              (CamlinternalFormatBasics.String_literal " inbox_ema: "
                (CamlinternalFormatBasics.Int CamlinternalFormatBasics.Int_d
                  CamlinternalFormatBasics.No_padding
                  CamlinternalFormatBasics.No_precision
                  (CamlinternalFormatBasics.String_literal " head inbox: "
                    (CamlinternalFormatBasics.Alpha
                      (CamlinternalFormatBasics.String_literal
                        " commitment tail: "
                        (CamlinternalFormatBasics.Alpha
                          (CamlinternalFormatBasics.String_literal
                            " commitment head: "
                            (CamlinternalFormatBasics.Alpha
                              (CamlinternalFormatBasics.String_literal
                                " last_removed_commitment_hash: "
                                (CamlinternalFormatBasics.Alpha
                                  CamlinternalFormatBasics.End_of_format))))))))))))))
      "oldest_inbox_level: %a cost_per_byte: %a inbox_ema: %d head inbox: %a commitment tail: %a commitment head: %a last_removed_commitment_hash: %a")
    (Format.pp_print_option None Tx_rollup_level_repr.pp) oldest_inbox_level
    Tez_repr.pp burn_per_byte inbox_ema
    (Format.pp_print_option None
      (fun (fmt : Format.formatter) =>
        fun (function_parameter :
          Tx_rollup_level_repr.level * Raw_level_repr.raw_level) =>
          let '(tx_lvl, tezos_lvl) := function_parameter in
          Format.fprintf fmt
            (CamlinternalFormatBasics.Format
              (CamlinternalFormatBasics.Char_literal "(" % char
                (CamlinternalFormatBasics.Alpha
                  (CamlinternalFormatBasics.String_literal ", "
                    (CamlinternalFormatBasics.Alpha
                      (CamlinternalFormatBasics.Char_literal ")" % char
                        CamlinternalFormatBasics.End_of_format))))) "(%a, %a)")
            Tx_rollup_level_repr.pp tx_lvl Raw_level_repr.pp tezos_lvl))
    head_level (Format.pp_print_option None Tx_rollup_level_repr.pp)
    commitment_tail_level
    (Format.pp_print_option None
      (fun (fmt : Format.formatter) =>
        fun (function_parameter :
          Tx_rollup_level_repr.level *
            Tx_rollup_commitment_repr.Commitment_hash.t) =>
          let '(tx_lvl, tezos_lvl) := function_parameter in
          Format.fprintf fmt
            (CamlinternalFormatBasics.Format
              (CamlinternalFormatBasics.Char_literal "(" % char
                (CamlinternalFormatBasics.Alpha
                  (CamlinternalFormatBasics.String_literal ", "
                    (CamlinternalFormatBasics.Alpha
                      (CamlinternalFormatBasics.Char_literal ")" % char
                        CamlinternalFormatBasics.End_of_format))))) "(%a, %a)")
            Tx_rollup_level_repr.pp tx_lvl
            Tx_rollup_commitment_repr.Commitment_hash.pp tezos_lvl))
    commitment_head_level
    (Format.pp_print_option None Tx_rollup_commitment_repr.Commitment_hash.pp)
    last_removed_commitment_hash.

Definition update_burn_per_byte (function_parameter : t) : int -> int -> t :=
  let
    '{| t.burn_per_byte := burn_per_byte; t.inbox_ema := inbox_ema |} as
      state_value := function_parameter in
  fun (final_size : int) =>
    fun (hard_limit : int) =>
      let threshold_increase := 90 in
      let threshold_decrease := 80 in
      let variation_factor := 5 in
      let inbox_ema_multiplier := 165 in
      let inbox_ema :=
        ((final_size *i inbox_ema_multiplier) +i
        (inbox_ema *i (10000 -i inbox_ema_multiplier))) /i 10000 in
      let percentage := (inbox_ema *i 100) /i hard_limit in
      let computation :=
        if
          (threshold_decrease <i percentage) &&
          (percentage <=i threshold_increase)
        then
          return? burn_per_byte
        else
          let? variation :=
            let? x_value :=
              Tez_repr.op_starquestion burn_per_byte variation_factor in
            Tez_repr.op_divquestion x_value 100 in
          let variation :=
            if Tez_repr.op_eq variation Tez_repr.zero then
              Tez_repr.one_mutez
            else
              variation in
          if threshold_increase <i percentage then
            Tez_repr.op_plusquestion burn_per_byte variation
          else
            if
              (percentage <i threshold_decrease) &&
              (Tez_repr.op_lt Tez_repr.zero burn_per_byte)
            then
              Tez_repr.op_minusquestion burn_per_byte variation
            else
              return? burn_per_byte in
      match computation with
      | Pervasives.Ok burn_per_byte =>
        t.with_inbox_ema inbox_ema
          (t.with_burn_per_byte burn_per_byte state_value)
      | Pervasives.Error _ =>
        t.with_inbox_ema inbox_ema
          (t.with_burn_per_byte Tez_repr.max_mutez state_value)
      end.

Definition inboxes_count (function_parameter : t) : int :=
  let '{|
    t.oldest_inbox_level := oldest_inbox_level;
      t.head_level := head_level
      |} := function_parameter in
  match (oldest_inbox_level, head_level) with
  | (Some oldest_level, Some (newest_level, _)) =>
    let delta :=
      Int32.succ (Tx_rollup_level_repr.diff_value newest_level oldest_level) in
    Int32.to_int (Compare.Int32.(Compare.S.max) 0 delta)
  | _ => 0
  end.

Definition committed_inboxes_count (function_parameter : t) : int :=
  let '{|
    t.oldest_inbox_level := oldest_inbox_level;
      t.commitment_head_level := commitment_head_level
      |} := function_parameter in
  match (oldest_inbox_level, commitment_head_level) with
  | (Some oldest_level, Some (newest_level, _)) =>
    let delta :=
      Int32.succ (Tx_rollup_level_repr.diff_value newest_level oldest_level) in
    Int32.to_int (Compare.Int32.(Compare.S.max) 0 delta)
  | _ => 0
  end.

Definition uncommitted_inboxes_count (function_parameter : t) : int :=
  let '{|
    t.commitment_head_level := commitment_head_level;
      t.head_level := head_level
      |} := function_parameter in
  match (commitment_head_level, head_level) with
  | (Some (oldest_level, _), Some (newest_level, _)) =>
    let delta := Tx_rollup_level_repr.diff_value newest_level oldest_level in
    Int32.to_int (Compare.Int32.(Compare.S.max) 0 delta)
  | _ => 0
  end.

Definition finalized_commitments_count (function_parameter : t) : int :=
  let '{|
    t.commitment_tail_level := commitment_tail_level;
      t.oldest_inbox_level := oldest_inbox_level
      |} := function_parameter in
  match (commitment_tail_level, oldest_inbox_level) with
  | (Some oldest_level, Some newest_level) =>
    let delta := Tx_rollup_level_repr.diff_value newest_level oldest_level in
    Int32.to_int (Compare.Int32.(Compare.S.max) 0 delta)
  | _ => 0
  end.

Definition commitment_head_level (state_value : t)
  : option Tx_rollup_level_repr.t :=
  if (committed_inboxes_count state_value) =i 0 then
    None
  else
    Option.map Pervasives.fst state_value.(t.commitment_head_level).

Definition commitment_tail_level (state_value : t)
  : option Tx_rollup_level_repr.t :=
  if (finalized_commitments_count state_value) =i 0 then
    None
  else
    state_value.(t.commitment_tail_level).

Definition head_level (state_value : t)
  : option (Tx_rollup_level_repr.t * Raw_level_repr.t) :=
  if (inboxes_count state_value) =i 0 then
    None
  else
    state_value.(t.head_level).

Definition oldest_inbox_level (state_value : t)
  : option Tx_rollup_level_repr.t :=
  if (inboxes_count state_value) =i 0 then
    None
  else
    state_value.(t.oldest_inbox_level).

Definition next_commitment_level (state_value : t)
  : M? Tx_rollup_level_repr.level :=
  match ((commitment_head_level state_value), (oldest_inbox_level state_value))
    with
  | (Some commitment_head, Some _) =>
    return? (Tx_rollup_level_repr.succ commitment_head)
  | (None, Some oldest_inbox) => return? oldest_inbox
  | (_, _) =>
    Error_monad.error_value (Build_extensible "No_uncommitted_inbox" unit tt)
  end.

Definition next_commitment_predecessor (state_value : t)
  : option Tx_rollup_commitment_repr.Commitment_hash.t :=
  Option.map Pervasives.snd state_value.(t.commitment_head_level).

Definition record_inbox_creation
  (t_value : t) (level : Raw_level_repr.raw_level)
  : M? (t * Tx_rollup_level_repr.level) :=
  let? tx_level :=
    match t_value.(t.head_level) with
    | Some (tx_lvl, tezos_lvl) =>
      let? '_ :=
        if Raw_level_repr.op_lteq level tezos_lvl then
          Error_monad.error_value
            (Build_extensible "Internal_error" string
              "Trying to create an inbox in the past")
        else
          return? tt in
      return? (Tx_rollup_level_repr.succ tx_lvl)
    | None => return? Tx_rollup_level_repr.root
    end in
  let oldest_inbox_level :=
    Some (Option.value_value t_value.(t.oldest_inbox_level) tx_level) in
  return?
    ((t.with_head_level (Some (tx_level, level))
      (t.with_oldest_inbox_level oldest_inbox_level t_value)), tx_level).

Definition record_inbox_deletion
  (state_value : t) (candidate : Tx_rollup_level_repr.level) : M? t :=
  match
    (state_value.(t.oldest_inbox_level),
      match state_value.(t.oldest_inbox_level) with
      | Some level =>
        (0 <i (inboxes_count state_value)) &&
        (Tx_rollup_level_repr.op_eq candidate level)
      | _ => false
      end) with
  | (Some level, true) =>
    let oldest_inbox_level := Some (Tx_rollup_level_repr.succ level) in
    return? (t.with_oldest_inbox_level oldest_inbox_level state_value)
  | (_, _) =>
    Error_monad.error_value
      (Build_extensible "Internal_error" string
        "Trying to delete the wrong inbox")
  end.

Definition record_commitment_creation
  (state_value : t) (level : Tx_rollup_level_repr.t)
  (hash_value : Tx_rollup_commitment_repr.Commitment_hash.t) : M? t :=
  let commitment_tail_level :=
    Some (Option.value_value state_value.(t.commitment_tail_level) level) in
  let state_value :=
    t.with_commitment_tail_level commitment_tail_level state_value in
  match
    (((commitment_head_level state_value), (oldest_inbox_level state_value)),
      match
        ((commitment_head_level state_value), (oldest_inbox_level state_value))
        with
      | (Some commitment_head, Some _) =>
        Tx_rollup_level_repr.op_eq level
          (Tx_rollup_level_repr.succ commitment_head)
      | _ => false
      end,
      match
        ((commitment_head_level state_value), (oldest_inbox_level state_value))
        with
      | (None, Some oldest) => Tx_rollup_level_repr.op_eq level oldest
      | _ => false
      end) with
  | ((Some commitment_head, Some _), true, _) =>
    return?
      (t.with_commitment_head_level (Some (level, hash_value)) state_value)
  | ((None, Some oldest), _, true) =>
    return?
      (t.with_commitment_head_level (Some (level, hash_value)) state_value)
  | (_, _, _) =>
    Error_monad.error_value
      (Build_extensible "Internal_error" string
        "Trying to create a commitment at an incorrect level")
  end.

Definition record_commitment_rejection
  (state_value : t) (level : Tx_rollup_level_repr.level)
  (predecessor_hash : option Tx_rollup_commitment_repr.Commitment_hash.t)
  : M? t :=
  let unwrap_option {A : Set} (msg : string) (function_parameter : option A)
    : M? A :=
    match function_parameter with
    | Some x_value => return? x_value
    | _ =>
      Error_monad.error_value (Build_extensible "Internal_error" string msg)
    end in
  let check_none {A : Set} (msg : string) (function_parameter : option A)
    : M? unit :=
    match function_parameter with
    | None => return? tt
    | Some _ =>
      Error_monad.error_value (Build_extensible "Internal_error" string msg)
    end in
  match
    (((oldest_inbox_level state_value), (commitment_head_level state_value)),
      match
        ((oldest_inbox_level state_value), (commitment_head_level state_value))
        with
      | (Some inbox_tail, Some commitment_head) =>
        (Tx_rollup_level_repr.op_lteq inbox_tail level) &&
        (Tx_rollup_level_repr.op_lteq level commitment_head)
      | _ => false
      end) with
  | ((Some inbox_tail, Some commitment_head), true) =>
    match
      (((commitment_tail_level state_value), (Tx_rollup_level_repr.pred level)),
        match
          ((commitment_tail_level state_value),
            (Tx_rollup_level_repr.pred level)) with
        | (Some commitment_tail, Some pred_level) =>
          Tx_rollup_level_repr.op_lteq commitment_tail pred_level
        | _ => false
        end) with
    | ((Some commitment_tail, Some pred_level), true) =>
      let? pred_hash :=
        unwrap_option "Missing predecessor commitment" predecessor_hash in
      return?
        (t.with_commitment_head_level (Some (pred_level, pred_hash)) state_value)
    | ((None, Some pred_level), _) =>
      let? '_ := check_none "Unexpected predecessor hash" predecessor_hash in
      let? pred_hash :=
        unwrap_option "Missing commitment hash"
          state_value.(t.last_removed_commitment_hash) in
      return?
        (t.with_commitment_head_level (Some (pred_level, pred_hash)) state_value)
    | ((None, None), _) =>
      let? '_ :=
        check_none "Unexpected last removed commitment"
          state_value.(t.last_removed_commitment_hash) in
      return? (t.with_commitment_head_level None state_value)
    | (_, _) =>
      Error_monad.error_value
        (Build_extensible "Internal_error" string "Machine state inconsistency")
    end
  | (_, _) =>
    Error_monad.error_value
      (Build_extensible "Internal_error" string "No commitment to reject")
  end.

Definition record_commitment_deletion
  (state_value : t) (level : Tx_rollup_level_repr.level)
  (hash_value : Tx_rollup_commitment_repr.Commitment_hash.t) : M? t :=
  match
    ((commitment_tail_level state_value),
      match commitment_tail_level state_value with
      | Some tail => Tx_rollup_level_repr.op_eq level tail
      | _ => false
      end) with
  | (Some tail, true) =>
    return?
      (t.with_commitment_tail_level (Some (Tx_rollup_level_repr.succ tail))
        (t.with_last_removed_commitment_hash (Some hash_value) state_value))
  | (_, _) =>
    Error_monad.error_value
      (Build_extensible "Internal_error" string
        "Trying to remove an incorrect commitment")
  end.

Definition burn_cost
  (limit : option Tez_repr.t) (state_value : t) (size_value : int)
  : M? Tez_repr.t :=
  let? burn :=
    Tez_repr.op_starquestion state_value.(t.burn_per_byte)
      (Int64.of_int size_value) in
  match
    (limit,
      match limit with
      | Some limit => Tez_repr.op_gteq limit burn
      | _ => false
      end) with
  | (Some limit, true) =>
    Error_monad.error_value
      (Build_extensible "Submit_batch_burn_excedeed"
        Tx_rollup_errors_repr.Submit_batch_burn_excedeed
        {| Tx_rollup_errors_repr.Submit_batch_burn_excedeed.burn := burn;
          Tx_rollup_errors_repr.Submit_batch_burn_excedeed.limit := limit |})
  | (_, _) => return? burn
  end.
